/*
 * Project: Image
 * File: Generator.java
 * Package: imageviewer.rgb
 *
 * Created on Jul 19, 2007 10:20:48 PM
 * By Carlos Fernando Bella Cruz
 */
package imageviewer.rgb;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;

import com.sun.image.codec.jpeg.JPEGImageEncoder;

/**
 * @author Carlos Fernando Bella Cruz
 *
 * Generator of image file
 */
public class Generator {

    Color[][] color;

    /**
     * Constructor with bidimensional array of colors 
     * @param color
     */
    public Generator(Color[][] color) {

        this.color = color;
    }

    /**
     * Draw image into canvas
     * @return the image
     */
    public BufferedImage getImage() {

        // Create an image with specific size
        BufferedImage image = new BufferedImage(Configuration.X,
            Configuration.Y, BufferedImage.TYPE_INT_RGB);

        Graphics g = image.getGraphics();

        for (int i = 0; i < Configuration.X; i++)
            for (int j = 0; j < Configuration.Y; j++) {
                g.setColor(color[i][j]);
                g.drawLine(i, j, i, j);
            }

        return image;
    }

    /**
     * Save the image into a file
     * @param fileName java.lang.String
     */
    public void saveImage(String fileName) {

        try {

            FileOutputStream out = new FileOutputStream(new File(fileName));

            JPEGImageEncoder encoder = new sun.awt.image.codec.JPEGImageEncoderImpl(
                out);

            encoder.encode(getImage());

            out.close();

        }
        catch(java.io.IOException e) {
            e.printStackTrace();
        }
    }
}
