/* depende.c - Implementacao das funcoes dependentes do ambiente grafico.
	       Definir no arquivo depende.h:
                 UNIX para compilar no sistema Unix.
		 VGA_MONO para usar funcoes VGA 320x200 c/ 256c,
		 A10 Para a pala Artist 10 e
		 P_VGA para funcoes da placa VGA 460X480 c/ 16c. */

#ifdef UNIX
#else
#include <graphics.h>
#include "depende.h"

#if defined (A10)

#include "artist10\\art10lib.h"

#endif

void set_64_gray_palette (int ncores)
{
  int i;
  unsigned char r[256], g[256], b[256];

  if ((ncores < 2) || (ncores > 256))
    ncores = 256;
  for (i = 0; i < ncores; i++)
    r[i] = g[i] = b[i] = (i * 63) / (ncores-1);
#if defined (A10)
  A10_Setpalette (0, 256, r, g, b);
#elif defined (P_VGA)
  /* Nao e possivel */
#elif defined (VGA_MONO)
  for (i = 0; i < ncores; i++)
    setrgbpalette (i, r[i], g[i], b[i]);
#endif
}

/*-------------------------------------------------------------*/
void poligono_pintado (int cor, int n, int *p)
{
  setcolor (cor);
  setfillstyle (SOLID_FILL, cor);
  fillpoly (n, p);
}

/*-------------------------------------------------------------*/
void ponto_pintado (int x, int y, int cor)
{
#if defined (A10)

  A10_Amove (x, y);
  A10_Setcolor (cor);
  A10_Dot ();

#elif defined (VGA_MONO)

  putpixel (x, y, cor);

#elif defined (P_VGA)

  putpixel (x, y, cor);

#endif
}

/*-------------------------------------------------------------*/
int huge Always()
{
  return 0;  /* Place appropriate video mode here: 0,1,2 or 3 */
}

/*-------------------------------------------------------------*/
void ambiente_grafico (void)
{
#if defined (A10)

  A10_Init (2);
  A10_Set_n_gray_palette (64);

#elif defined (VGA_MONO)

  int GraphDrv = DETECT, GraphMod;

  installuserdriver ("VGA256", Always);
  initgraph (&GraphDrv, &GraphMod, ".");
  cleardevice ();

#elif defined (P_VGA)

 int gd = VGA, gm = VGAHI;

 initgraph (&gd, &gm, "");

#endif
}

/*-------------------------------------------------------------*/
void fim_ambiente_grafico (void)
{
#if defined (A10)

#elif defined (VGA_MONO)

  closegraph ();

#elif defined (P_VGA)

  closegraph ();

#endif
}


void mostra_malha (malha *m)
{
  int i, j;

  for(i = 0; i < m->n_pol; i++)
  {
    poligono *pol = &m->polig[i];
    ponto3d p3d, q3d;
    ponto2d p2d, q2d;

    muda_referencial (&m->vert[pol->vert[pol->n_vert-1]], &p3d);
    projecao (&p3d, &p2d);
    mapeia (&p2d, &q2d);

    MOVETO ((int) q2d.x, (int) q2d.y); 

    for (j = 0; j < pol->n_vert; j++)
    {
      muda_referencial (&m->vert[pol->vert[j]], &p3d);
      projecao (&p3d, &p2d);
      mapeia (&p2d, &q2d);

      LINETO ((int)q2d.x, (int)q2d.y); 
    }
  }
}
#endif /* UNIX */
