%{

/* Variaveis de interface entre LEX e YACC */

extern int Y_linha;
extern float L_float;
extern char L_nome [MAXSTRING];

%}

a             [aA]
b             [bB]
c             [cC]
d             [dD]
e             [eE]
f             [fF]
g             [gG]
h             [hH]
i             [iI]
j             [jJ]
k             [kK]
l             [lL]
m             [mM]
n             [nN]
o             [oO]
p             [pP]
q             [qQ]
r             [rR]
s             [sS]
t             [tT]
u             [uU]
v             [vV]
x             [xX]
y             [yY]
z             [zZ]

delim         [ \t]+

digito        [0-9]
digitos       {digito}+
sinaldigitos  ("+"|"-")?{digitos}
frac_opcion   ("."{digitos})?
exp_opcion    (E{sinaldigitos})?
numero        {sinaldigitos}{frac_opcion}{exp_opcion}

letra         [A-Za-z_]
ident         {letra}({letra}|{digito})*

%%

delim                                   { /* nao levar em consideracao */ };
"\n"                                    { Y_linha++; };

{c}{a}{m}{e}{r}{a}                      { return CAMERA; };
{a}{m}{b}{i}{e}{n}{t}{e}                { return AMBIENTE; };
{m}{a}{t}{e}{r}{i}{a}{i}{s}             { return MATERIAIS; };
{o}{b}{j}{e}{t}{o}{s}                   { return OBJETOS; };

{o}{b}{s}{e}{r}{v}{a}{d}{o}{r}          { return OBSERVADOR; };
{v}{e}{r}{t}{i}{c}{a}{l}                { return VERTICAL; };
{d}{i}{r}{e}{c}{a}{o}                   { return DIRECAO; };
{n}{o}{r}{m}{a}{l}                      { return NORMAL; };
{f}{o}{c}{o}                            { return FOCO; };
{j}{a}{n}{e}{l}{a}                      { return JANELA; };
{p}{r}{o}{j}{e}{c}{a}{o}                { return PROJECAO; };
{p}{a}{r}{a}{l}{e}{l}{a}                { return PARALELA; };
{p}{e}{r}{s}{p}{e}{c}{t}{i}{v}{a}       { return PERSPECTIVA; }:
{b}{a}{s}{e}                            { return BASE; };

{p}{o}{n}{t}{u}{a}{l}                   { return PONTUAL; };
{s}{p}{o}{t}                            { return SPOT; };
{s}{o}{l}                               { return SOL; };

{t}{r}{a}{n}{s}{l}{a}{c}{a}{o}          { return TRANSLACAO; };
{e}{s}{c}{a}{l}{a}                      { return ESCALA; };
{r}{o}{t}{a}{c}{a}{o}{x}                { return ROTACAOX; };
{r}{o}{t}{a}{c}{a}{o}{y}                { return ROTACAOY; };
{r}{o}{t}{a}{c}{a}{o}{z}                { return ROTACAOZ; };
{m}{a}{t}{r}{i}{z}                      { return MATRIZ; };

"+"                                     { return ADICAO; };
"-"                                     { return SUBTRACAO; };
"*"                                     { return MULTIPLICACAO; };
"/"                                     { return DIVISAO; };

"="                                     { return IGUAL; };

","                                     { return VIRGULA; };

"{"                                     { return ABRECHAVE; };
"}"                                     { return FECHACHAVE; };

"["                                     { return ABRECOLCH; };
"]"                                     { return FECHACOLCH; };

"("                                     { return ABREPARENT; };
")"                                     { return FECHAPARENT; };

{d}{e}                                  { return DE; };

{numero}                                {
                                          sscanf (yytext, "%f", &L_float);
                                          return NUMERO;
                                        };

{ident}                                 {
                                          strcpy (L_nome, yytext);
                                          return NOME;
                                        };
%%
