/* main.c */


#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define DOS

#ifdef DOS
#include "f.h"
#include "camera.h"
#include "malha.h"
#else
#include "../bibliot/f.h"
#include "../bibliot/camera.h"
#include "../bibliot/malha.h"
#endif

#include "sl.h"
#include "main.h"


/*--------------------------------------------------------------*/
/* Separa o nome da extensao de um arquivo.                     */
/*--------------------------------------------------------------*/
char *separa_nome (s1, s2)
char *s1;
char *s2;
{
  int i;

  for(i=0; (s2[i] != '.') && s2[i]; i++)
    s1[i] = s2[i];
  s1[i] = '\0';

  return s1;
}

void tela_ajuda ()
{
    printf("sl [opcoes] <arquivo de cena> [arquivo de saida]\n\n");
    printf("   /t100x100   : Define o largura e o comprimento da tela.\n");
    printf("   /c64        : Numero maximo de cores geradas.\n");
    printf("   /G          : Usa o metodo Gouraud.\n");
    printf("   /P          : \"   \"  \"     Phong.\n");
    printf("   /H ou /?    : Mostra esta tela.\n");
    exit(0);
}

int maxcolor=256; /* numero maximo de cor que pode ser gerada,             */
				 /* usado para calcular a cor dos vertices e pontos.      */
				 /* Pode ser setado via linha de comando para outro valor.*/

unsigned int  tamx, tamy;
static metodo rendering = GOURAUD;
static char nome_arq_cena[TAM_NOME_ARQUIVO],
	    nome_arq_saida[TAM_NOME_ARQUIVO];

void trata_args(argc, argv)
int argc;
char **argv;
{

  int i;


  if (argc == 1)
    tela_ajuda ();

  strcpy(nome_arq_cena,"");
  strcpy(nome_arq_saida,"saida");

  for (i=1; i < argc; i++)
  {
    if (argv [i][0] == '/')
      switch (argv [i][1])
      {
        case 't':
        {
          int p;

	  for (p = strlen (argv[i]) - 1; p > 0; p--)
	    if (!isdigit (argv [i][p]))
	    {
	      tamy = atoi (argv [i]+p+1);
	      argv [i][p] = '\0';
	      break;
	    }
	  for (p = strlen (argv[i]) - 1; p > 0; p--)
	    if (!isdigit (argv [i][p]))
	    {
	      tamx = atoi (argv [i]+p+1);
	      argv [i][p+1] = '\0';
	      break;
	    }
	 break;
	}
	case 'c':
	{
	  maxcolor = atoi (argv [i]+2);
	  break;
	}
	case 'h':
	case 'H':
	case '?':
	  tela_ajuda ();
	case 'G':
	case 'g':
	{
	  rendering = GOURAUD;
	  break;
	}
	case 'P':
	case 'p':
	{
	  rendering = PHONG;
	  break;
	}
      }
    else
    {
      if (!strcmp (nome_arq_cena, ""))
	strcpy (nome_arq_cena, argv [i]);
      else
	strcpy (nome_arq_saida, argv [i]);
    }
  }
}

void main(argc, argv)
int argc;
char *argv[];
{
  t_cena *cena= ALOCA(1, t_cena);

  trata_args(argc, argv);
  
  le_arquivo_entrada(nome_arq_cena); /* compilador da linguagem */
   
  le_cena(cena, "scanline.in");

  if(rendering == PHONG)
    scan_line_phong(cena, tamx, tamy, nome_arq_saida);
  else
    scan_line_gour(cena, tamx, tamy, nome_arq_saida);

}












