
#define INFINITO (double)1e30
#define COR_BACKGROUND 0

typedef struct aresta{
  unsigned int v1, v2;
}aresta;

typedef struct vertice_proj{
  int x, y;
  double z;
}vertice_proj;

typedef struct nodo_la{
  aresta a;
  unsigned int polig;
  struct nodo_la *prox;
}nodo_la;

typedef struct nodo_laa{
  double x, incrx,
	z, incrz,
	xm, incrxm,
	ym, incrym,
	cor[3], incrcor[3];
  ponto3d normal, incrnormal;
  int delta_y, polig;
  struct nodo_laa *prox;
}nodo_laa;

typedef struct z_buffer_otimizado {
   t_cena *cena;
   ponto3d r;
   ponto3d normal;
   poligono *polig;
   double cor[3];
} z_buffer_otimizado;

void cor_ponto PROTO ((t_cena *, ponto3d *, ponto3d *, poligono *, true_color));

void calc_luz_pontual PROTO((t_luz *, ponto3d *, ponto3d *, int, t_malha *, double []));

void calc_luz_spot PROTO((t_luz *, ponto3d *, ponto3d *, int, t_malha *, double []));

void calc_luz_sol PROTO((t_luz *, ponto3d *, ponto3d *, int, t_malha *, double []));

void calc_cor_vert PROTO ((t_cena *));

void cria_vert_base_observador PROTO ((t_malha *m));

vertice_proj *cria_vert_proj PROTO ((t_malha *, vertice_proj *));

nodo_la **bucket_sort PROTO ((nodo_la **, t_malha *, vertice_proj *, int));

void muda_referencial_luzes PROTO((t_cena *));

void inicializa_z_buffer PROTO ((double *, unsigned int));

void insere_laa PROTO ((nodo_laa *, nodo_laa *));

nodo_la *pega_nodo_gour PROTO ((t_malha *, nodo_la *, nodo_laa *, unsigned int, vertice_proj *));

nodo_la *pega_nodo_phong PROTO ((t_malha *, nodo_la *, nodo_laa *, unsigned int, vertice_proj *));

void insere_nova_linha_laa_gour PROTO ((t_malha *, nodo_la *, nodo_laa *, unsigned int, vertice_proj *));

void insere_nova_linha_laa_phong PROTO ((t_malha *, nodo_la *, nodo_laa *, unsigned int, vertice_proj *));

void traca_spans_gour PROTO ((int, nodo_laa *, double *));

void traca_spans_phong PROTO ((t_cena *, int, nodo_laa *, double *));

void atualiza_laa_gour PROTO ((nodo_laa *));

void atualiza_laa_phong PROTO ((nodo_laa *));

void scan_line_phong PROTO((t_cena *, unsigned int, unsigned int, char *));

void cria_vert_base_observador_gour PROTO ((t_malha *));

double *calc_cor_vert_gour PROTO ((t_cena *, ponto3d *, ponto3d *));

void scan_line_gour PROTO ((t_cena *, unsigned int, unsigned int, char *));



