%{ 

#define GRAUS_RADIANOS 0.0174532

%}

%union
{
  float valor;
}

%start cena

%token CAMERA AMBIENTE MATERIAIS OBJETOS
%token OBSERVADOR VERTICAL DIRECAO NORMAL FOCO JANELA PROJECAO BASE
%token PARALELA PERSPECTIVA
%token PONTUAL SPOT SOL
%token TRANSLACAO ESCALA ROTACAOX ROTACAOY ROTACAOZ MATRIZ
%token ADICAO SUBTRACAO MULTIPLICACAO DIVISAO 
%token NOME
%token ABRECHAVE FECHACHAVE
%token ABRECOLCH FECHACOLCH
%token ABREPARENT FECHAPARENT
%token DE
%token VIRGULA IGUAL

%token <valor> NUMERO
%type  <valor> expr_num

%left ADICAO SUBTRACAO
%left MULTIPLICACAO DIVISAO
%left MENOS_UNARIO 

%%

cena            : /* sentenca vazia */
                |
                  def_cena      cena
                |
                  def_ambiente  cena
                |
                  def_materiais cena
                |
                  def_objetos   cena
                |
                  error { printf ("Erro na definicao de grupo."); }
                ;



def_cena        : CAMERA
                    ABRECHAVE
                      camera
                    FECHACHAVE
                |
                  error { printf ("Erro na definicao do grupo camera."); }
                ;

camera          : /* sentenca vazia */
                |
                  observador camera
                |
                  vertical   camera
                |
                  direcao    camera
                |
                  normal     camera
                |
                  foco       camera
                |
                  janela     camera
                |
                  projecao   camera
                |
		  base       camera
                |
                  error { printf ("Erro num componente da camera.\n"); }
                ;

observador      : OBSERVADOR
                  ponto {
                    TS_observador [0] = Y_ponto_x;
                    TS_observador [1] = Y_ponto_y;
                    TS_observador [2] = Y_ponto_z;
                  }
                |
                  error { printf ("Erro na definicao do observador.\n"); }
                ;

vertical        : VERTICAL
                  ponto {
                    TS_vertical [0] = Y_ponto_x;
                    TS_vertical [1] = Y_ponto_y;
                    TS_vertical [2] = Y_ponto_z;
                  }
                |
                  error { printf ("Erro na definicao da vertical.\n"); }
                ;

direcao         : DIRECAO
                  ponto {
                    TS_direcao [0] = Y_ponto_x;
                    TS_direcao [1] = Y_ponto_y;
                    TS_direcao [2] = Y_ponto_z;
                  }
                |
                  error { printf ("Erro na definicao da direcao.\n"); }
                ;

normal          : NORMAL
                  ponto {
                    TS_normal [0] = Y_ponto_x;
                    TS_normal [1] = Y_ponto_y;
                    TS_normal [2] = Y_ponto_z;
                  }
                |
                  error { printf ("Erro na definicao da normal.\n"); }
                ;

foco            : FOCO numero { TS_foco = L_float; }
                |
                  error { printf ("Erro na definicao do foco.\n"); }
                ;

janela          : JANELA numero { TS_janela [0] = L_float; }
                         numero { TS_janela [1] = L_float; }
                         numero { TS_janela [2] = L_float; }
                         numero { TS_janela [3] = L_float; }
                |
                  error { printf ("Erro na definicao da janela.\n"); }
                ;

projecao        : PROJECAO IGUAL tipo
                |
                  error { printf ("Erro na definicao do tipo de projecao.\n"); }
                ;

base            : BASE ABRECOLCH
                         numero { TS_base [0] [0] = L_float; }
                         numero { TS_base [0] [1] = L_float; }
                         numero { TS_base [0] [2] = L_float; }
                         numero { TS_base [1] [0] = L_float; }
                         numero { TS_base [1] [1] = L_float; }
                         numero { TS_base [1] [2] = L_float; }
                         numero { TS_base [2] [0] = L_float; }
                         numero { TS_base [2] [1] = L_float; }
                         numero { TS_base [2] [2] = L_float; }
                       FECHACOLCH
                ;

tipo            : PARALELA         { TS_projecao = TS_PARALELA; };
                |
                  PERSPECTIVA    { TS_projecao = TS_PERSPECTIVA; };
                |
                  error { printf ("Tipo de projecao nao reconhecido.\n"); }
                ;



def_ambiente    : AMBIENTE ABRECHAVE descr_luzes FECHACHAVE
                |
                  error { printf ("Erro na definicao do grupo ambiente.\n"); }
                ;

descr_luzes     : /* sentenca vazia */
		|
		  descr_luz descr_luzes
		| 
		  error { printf ("Erro na definicao das luzes.\n"); }
		;

descr_luz       : ponto {
                    TS_luz_ambiente [0] = Y_ponto_x;
                    TS_luz_ambiente [1] = Y_ponto_y;
                    TS_luz_ambiente [2] = Y_ponto_z; 
                  }
                |
                  NOME {
                    luz_temp = aloca_luz ();
                    strcpy (luz_temp->nome, L_nome);
                  }
                  ABRECHAVE
                    numero  { luz_temp->kd = L_float; }
                    numero  { luz_temp->ks = L_float; }
                    numero  { luz_temp->ka = L_float; }
                    descr_tipo_luz
                  FECHACHAVE { insere_luz_lista (luz_temp); }
                |
		  error { printf ("Erro na definicao de uma luz.\n"); }
                ;

descr_tipo_luz  : PONTUAL
                  ponto {
                    luz_temp->tipo_luz = S_PONTUAL;
                    luz_temp->posicao [0] = Y_ponto_x;
                    luz_temp->posicao [1] = Y_ponto_y;
                    luz_temp->posicao [2] = Y_ponto_z;
                  }
                |
                  SPOT
                  ponto {
                    luz_temp->tipo_luz = S_SPOT;
                    luz_temp->posicao [0] = Y_ponto_x;
                    luz_temp->posicao [1] = Y_ponto_y;
                    luz_temp->posicao [2] = Y_ponto_z;
                  }
                  vetor {
                    luz_temp->direcao [0] = Y_ponto_x;
                    luz_temp->direcao [1] = Y_ponto_y;
                    luz_temp->direcao [2] = Y_ponto_z;
                  }
                  numero { luz_temp->abertura = L_float * GRAUS_RADIANOS; }
                |
                  SOL
                  vetor {
                    luz_temp->tipo_luz = S_SOL;
                    luz_temp->direcao [0] = Y_ponto_x;
                    luz_temp->direcao [1] = Y_ponto_y;
                    luz_temp->direcao [2] = Y_ponto_z;
                  }
                |
                  error { printf ("Erro numa descricao de luz.\n"); }
                ;


def_materiais   : MATERIAIS ABRECHAVE descr_materiais FECHACHAVE
                |
                  error { printf ("Erro na definicao do grupo de materiais.\n"); }
                ;

descr_materiais : /* sentenca vazia */
		|
		  descr_material descr_materiais
		|
		  error { printf ("Erro na descriacao dos materiais.\n"); }
		;

descr_material  : NOME {
                    mater_temp = aloca_material ();
                    strcpy (mater_temp->nome, L_nome);
                  }
                  ABRECHAVE
                    numero { mater_temp->kd [0] = L_float; }
                    numero { mater_temp->ks [0] = L_float; }
                    numero { mater_temp->ka [0] = L_float; }
                    numero { mater_temp->kd [1] = L_float; }
                    numero { mater_temp->ks [1] = L_float; }
                    numero { mater_temp->ka [1] = L_float; }
                    numero { mater_temp->kd [2] = L_float; }
                    numero { mater_temp->ks [2] = L_float; }
                    numero { mater_temp->ka [2] = L_float; }

                    numero { mater_temp->const_phong = L_float; }
                  FECHACHAVE { insere_mater_lista (mater_temp); }
                |
		  error { printf ("Erro na descriacao de um material.\n"); } 
                ;

def_objetos     : OBJETOS ABRECHAVE descr_objetos FECHACHAVE
                |
                  error { printf ("Erro na definicao do grupo de objetos.\n"); }
                ;

descr_objetos   :  /* sentenca vazia */
                |
		  descr_objeto descr_objetos
                |
		  error { printf ("Erro na descriacao dos objetos.\n"); }
                ;

descr_objeto    : NOME {
		    if ((objeto_temp = pesquisa_objeto (L_nome)) == NULL) {
                      objeto_temp = aloca_objeto ();
                      strcpy (objeto_temp->nome, L_nome);
                      insere_objeto_grafo (objeto_temp);
                    }
                  }
                  ABRECHAVE
                  expr
                  FECHACHAVE
                  objeto_material
                |
                  error { printf ("Erro na definicao de um objeto.\n"); }
                ;

objeto_material : { /* objeto nao possui material, deixar o apont. com NULL */ }
                |
                  DE
                  nome_material {
                    if (liga_objeto_material (objeto_temp, Y_nome) == FALSO) {
                      printf ("Erro, nao existe objeto %s\n", Y_nome);
                      desaloca_memoria ();
                      exit (EXIT_FAILURE);
                    }
                  }
                |
                  error { printf ("Erro na definicao de um material de um objeto.\n"); }
                ;

expr            : NOME {
                    if ((objeto_filho_temp = pesquisa_objeto (L_nome)) == NULL){
                      objeto_filho_temp = aloca_objeto ();
                      strcpy (objeto_filho_temp->nome, L_nome);
                      insere_objeto_grafo (objeto_filho_temp);
                    }
                    coloque_identidade_matriz (Y_matriz);
                  }
                  transf { liga_pai_filho (objeto_temp, objeto_filho_temp); }
                |
                  expr ADICAO expr            { /* Uniao */ }
                |
                  expr SUBTRACAO expr         { /* Diferenca */ }
                |
                  expr MULTIPLICACAO expr     { /* Intersecao */ }
                |
                  ABREPARENT { estado_parenteses++; }
                  expr
                  FECHAPARENT {
                    estado_parenteses--;
                    coloque_identidade_matriz (Y_matriz);
                  }
                  transf {
                    atualiza_transformacoes ();
                    coloque_identidade_matriz (Y_matriz);
                  }
                |
                  error { printf ("Erro numa expressao de um objeto.\n"); }
                ;

transf          : /* sentenca vazia */
                |
                  TRANSLACAO
                  ponto {
                    coloque_identidade_matriz (Y_matriz_temp);
                    Y_matriz_temp [3] [0] = Y_ponto_x;
                    Y_matriz_temp [3] [1] = Y_ponto_y;
                    Y_matriz_temp [3] [2] = Y_ponto_z;
                    multiplique_matriz (Y_matriz, Y_matriz_temp);
                  }
                  transf
                |
                  ESCALA
                  ponto {
                    coloque_identidade_matriz (Y_matriz_temp);
                    Y_matriz_temp [0] [0] = Y_ponto_x;
                    Y_matriz_temp [1] [1] = Y_ponto_y;
                    Y_matriz_temp [2] [2] = Y_ponto_z;
                    multiplique_matriz (Y_matriz, Y_matriz_temp);
                  }
                  transf
                |
                  ROTACAOX
                  numero {
                    coloque_identidade_matriz (Y_matriz_temp);
                    Y_matriz_temp [1] [1] = cos (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [1] [2] = sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [2] [1] = -sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [2] [2] = cos (L_float * GRAUS_RADIANOS);
                    multiplique_matriz (Y_matriz, Y_matriz_temp);
                  }
                  transf
                |
                  ROTACAOY
                  numero {
                    coloque_identidade_matriz (Y_matriz_temp);
                    Y_matriz_temp [0] [0] = cos (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [0] [2] = -sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [2] [0] = sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [2] [2] = cos (L_float * GRAUS_RADIANOS);
                    multiplique_matriz (Y_matriz, Y_matriz_temp);
                  }
                  transf
                |
                  ROTACAOZ
                  numero {
                    coloque_identidade_matriz (Y_matriz_temp);
                    Y_matriz_temp [0] [0] = cos (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [0] [1] = sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [1] [0] = -sin (L_float * GRAUS_RADIANOS);
                    Y_matriz_temp [1] [1] = cos (L_float * GRAUS_RADIANOS);
                    multiplique_matriz (Y_matriz, Y_matriz_temp);
                  }
                  transf
                |
                  MATRIZ
                  matriz { multiplique_matriz (Y_matriz, Y_matriz_temp); }
                  transf
                |
                  error { printf ("Erro na definicao de uma transformacao.\n"); }
                ;

nome_material   : NOME       { strcpy (Y_nome, L_nome); }
                ;

ponto           : vetor
                ;

vetor           : ABRECOLCH
                    numero   { Y_ponto_x = L_float; }
                    numero   { Y_ponto_y = L_float; }
                    numero   { Y_ponto_z = L_float; }
                  FECHACOLCH
                |
                  error { printf ("Erro na definicao de um vetor.\n"); }
                ;

matriz          : ABRECOLCH
                    numero { Y_matriz_temp [0] [0] = L_float; }
                    numero { Y_matriz_temp [0] [1] = L_float; }
                    numero { Y_matriz_temp [0] [2] = L_float; }
                    numero { Y_matriz_temp [0] [3] = L_float; }
                    numero { Y_matriz_temp [1] [0] = L_float; }
                    numero { Y_matriz_temp [1] [1] = L_float; }
                    numero { Y_matriz_temp [1] [2] = L_float; }
                    numero { Y_matriz_temp [1] [3] = L_float; }
                    numero { Y_matriz_temp [2] [0] = L_float; }
                    numero { Y_matriz_temp [2] [1] = L_float; }
                    numero { Y_matriz_temp [2] [2] = L_float; }
                    numero { Y_matriz_temp [2] [3] = L_float; }
                    numero { Y_matriz_temp [3] [0] = L_float; }
                    numero { Y_matriz_temp [3] [1] = L_float; }
                    numero { Y_matriz_temp [3] [2] = L_float; }
                    numero { Y_matriz_temp [3] [3] = L_float; }
                  FECHACOLCH
                |
                  error { printf ("Erro na definicao de uma matriz.\n"); }
                ;

numero          : NUMERO
		| 
		  ABREPARENT expr_num FECHAPARENT { L_float = $2; }
		;

expr_num        :  
		  ABREPARENT expr_num FECHAPARENT       { $$ = $2; }
		|
		  expr_num ADICAO expr_num              { $$ = $1 + $3; } 
		| 
		  expr_num SUBTRACAO expr_num           { $$ = $1 - $3; }
	        |
		  expr_num MULTIPLICACAO expr_num       { $$ = $1 * $3; }
		|
		  expr_num DIVISAO expr_num             { $$ = $1 / $3; }
                |
		  SUBTRACAO expr_num %prec MENOS_UNARIO { $$ = -$2; } 
                |
                  NUMERO                                { $$ = L_float; }
                ;

%%

#include "../ling/definic.h"
#include "../ling/lexical.c"
#include "../ling/symtable.c"
