#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <math.h>

#define DOS

#ifdef DOS
#include 'f.h"
#include "malha.h"
#include "camera.h"
#include "sl.h"
#else
#include "../bibliot/f.h"
#include "../bibliot/malha.h"
#include "../bibliot/camera.h"
#include "../sl/sl.h"
#endif

int maxcolor, tamx, tamy;

t_cena *cena;
t_malha *malha;

float *vert_tela_x, *vert_tela_y;

cria_vert_tela()
{
  int i;

  for(i=0; i < malha->n_vert; i++)
  {
    ponto3d p;
    ponto2d r, s;

    muda_referencial(&malha->vert[i], &p);
    projecao(&p, &r);
    mapeia(&r, &s);
    vert_tela_x[i] = s.x;
    vert_tela_y[i] = s.y;
  }
}


graf_inicializa ()
{
  int gd, gm;
  gd = DETECT;
  gm = VGAHI;

  initgraph (&gd, &gm, ".");

}

repaint ()
{
  int tamy, i, j;

    cria_vert_tela();

    cleardevice ();
    setcolor (WHITE);
    for (i = 0; i < malha->n_pol; i++){
      poligono *pol = &malha->polig[i];
      for (j = 0; j < pol->n_vert-1; j++) {
      line ((int) vert_tela_x[pol->vert[j]],
	    (int) vert_tela_y[pol->vert[j]],
	    (int) vert_tela_x[pol->vert[j+1]],
	    (int) vert_tela_y[pol->vert[j+1]]);
      }
      line((int) vert_tela_x[pol->vert[pol->n_vert-1]],
	   (int) vert_tela_y[pol->vert[pol->n_vert-1]],
	   (int) vert_tela_x[pol->vert[0]],
	   (int) vert_tela_y[pol->vert[0]]);
    }
}


main(int argc, char *argv [])
{
  int i;
  char c;

  if (argc != 2) {
    printf ("Wire Arquivo_de_Cena\n");
    exit (0);
  }

  maxcolor = 255;


  cena= ALOCA(1, t_cena);

  graf_inicializa ();

  tamx = getmaxx ();
  tamy = getmaxy ();

  le_arquivo_entrada(argv [1]); /* compilador da linguagem */

  le_cena(cena, "scanline.in");

  malha = &cena->malha;

  vert_tela_x = ALOCA(malha->n_vert, float);
  vert_tela_y = ALOCA(malha->n_vert, float);

  repaint ();
  do {
    c = getch ();
    switch (c) {
      case '-':
	afasta ();
	break;
      case '=':
	aproxima ();
	break;
      case '7':
	gira_orientacao ((float) 0.1);
	break;
      case '1':
	gira_orientacao ((float) -0.1);
	break;
      case '6':
	roda_horizontal ((float) 0.1);
	break;
      case '4':
	roda_horizontal ((float) -0.1);
	break;
      case '2':
	roda_vertical ((float) 0.1);
	break;
      case '8':
	roda_vertical ((float) -0.1);
	break;
      case 'l':
	direita_esquerda ((float) 0.1);
	break;
      case 'k':
	direita_esquerda ((float) -0.1);
	break;
      case 'q':
	sobe_desce ((float) 0.1);
	break;
      case 'a':
	sobe_desce ((float) -0.1);
	break;
      case ' ': {
      }
    }
    repaint ();

  } while (c != ' ');

  closegraph ();
  free (vert_tela_x);
  free (vert_tela_y);
  free (cena);

}


